package com.docus.server.service.impl;

import com.docus.core.util.ListUtils;
import com.docus.infrastructure.web.request.SearchDTO;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.convert.SchSystemParamsConvert;
import com.docus.server.dto.scheduling.management.schsystemparams.AddSchSystemParamsDTO;
import com.docus.server.dto.scheduling.management.schsystemparams.DeleteSchSystemParamsDTO;
import com.docus.server.dto.scheduling.management.schsystemparams.EditSchSystemParamsDTO;
import com.docus.server.entity.scheduling.management.SchSystemParams;
import com.docus.server.infrastructure.dao.ISchSystemParamsDao;
import com.docus.server.service.ISchSystemParamsService;
import com.docus.server.vo.scheduling.management.schsystemparams.SchSystemParamsVO;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * 系统参数表 服务实现类
 *
 * @author AutoGenerator
 * @since 2023-07-15
 */
@Service
public class SchSystemParamsServiceImpl implements ISchSystemParamsService {
    @Resource
    private ISchSystemParamsDao iSchSystemParamsDao;

    /**
     * 按主键查询
     *
     * @param id 主键Id
     * @return 实体
     */
    @Override
    public SchSystemParamsVO findById(String id) {
        return SchSystemParamsConvert.INSTANCE.convertVO(iSchSystemParamsDao.findById(id));
    }

    /**
     * 关键字搜索
     *
     * @param searchDTO 搜索参数
     * @return 分页列表
     */
    @Override
    public PageResult<SchSystemParamsVO> search(SearchDTO searchDTO) {
        return SchSystemParamsConvert.INSTANCE.convertVO(iSchSystemParamsDao.search(searchDTO));
    }

    /**
     * 新增
     *
     * @param addSchSystemParamsDTO 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean add(AddSchSystemParamsDTO addSchSystemParamsDTO) {
        SchSystemParams schSystemParams = SchSystemParamsConvert.INSTANCE.convertDO(addSchSystemParamsDTO);
        return iSchSystemParamsDao.add(schSystemParams);
    }

    /**
     * 编辑
     *
     * @param editSchSystemParamsDTO 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean edit(EditSchSystemParamsDTO editSchSystemParamsDTO) {
        SchSystemParams schSystemParams = SchSystemParamsConvert.INSTANCE.convertDO(editSchSystemParamsDTO);
        return iSchSystemParamsDao.edit(schSystemParams);
    }

    /**
     * 批量删除
     *
     * @param deleteSchSystemParamsDTO 删除参数
     * @return 成功或失败
     */
    @Override
    public int delete(DeleteSchSystemParamsDTO deleteSchSystemParamsDTO) {
        return iSchSystemParamsDao.delete(deleteSchSystemParamsDTO.getIds());
    }

    @Override
    public Map<String, SchSystemParams> find(List<Long> paramValueIds) {
        List<SchSystemParams> schSystemParams = iSchSystemParamsDao.findBy("paramValue", paramValueIds);
        return ListUtils.toMap(schSystemParams, SchSystemParams::getParamValue);
    }

}

